// roundup2 and rounddown2 are rather complex
//
// Confidence: High
// Copyright: (C) pfg
//
// Note: roundup2 is a special case of rounddown2 so it must be checked first.

@param@
@@

#include <sys/param.h>

@depends on param@
expression x, y;
@@

(
- (((x) + ((y) - 1)) & (~((y) - 1)))
+ roundup2(x, y)
|
- (((x) + (y) - 1) & (~((y) - 1)))
+ roundup2(x, y)
)

@depends on param disable paren@
expression x, y;
@@

- roundup2((x), y)
+ roundup2(x, y)

@depends on param disable paren@
expression x, y;
@@

- roundup2(x, (y))
+ roundup2(x, y)

@depends on param@
expression x, y;
@@

(
- ((x) & (~((y) - 1)))
+ rounddown2(x, y)
|
- ((~((x) - 1)) & (y))
+ rounddown2(x, y)
)

@depends on param disable paren@
expression x, y;
@@

- rounddown2((x), y)
+ rounddown2(x, y)

@depends on param disable paren@
expression x, y;
@@

- rounddown2(x, (y))
+ rounddown2(x, y)

